
CC	= gcc
LD	= ld
AR	= ar
LDFLAGS	= @LDFLAGS
LDFLAGS2= @LDFLAGS2
LDFILES	= @LDFILE

CFLAGS1 = -I../lib -I. -Ic:\gcc\include\sys
CFLAGS2 = -DGO32 -DPC98
CFLAGS3 = ${OPT_CFLAGS}
CFLAGS4 = -DPDEBUG=1
CFLAGS	= @CFLAGS

SOBJS1	= ml.o extend.o
SOBJS2	= exec1.o exec2.o exec3.o 
SOBJS3	= parse1.o parse2.o parse3.o std.o check.o scanner.o code.o
SOBJS4	= init.o stack.o class.o object.o func.o ident.o str.o alloc.o err.o
SOBJS	= ${SOBJS1} ${SOBJS2} ${SOBJS3} ${SOBJS4}
OBJS1	= main.o fary.o
OBJS	= ${OBJS1} ${SOBJS}

LIBS	= ../lib/lib.a
SLIBS	= ../lib/slib.a
HDRS	= _ml.h
SRCS	= ml.c extend.c err.c check.c stack.c object.c
CRT	= ../lib/crt32.o
LIBPATH	= c:\gcc\lib

all :	CFLAGS ml.h ml.dl ml.rel ml.a sml.a test

CFLAGS: makefile.go
	echo\ $(CFLAGS1) > CFLAGS
	echo\ $(CFLAGS2) >> CFLAGS
	echo\ $(CFLAGS3) >> CFLAGS
	echo\ $(CFLAGS4) >> CFLAGS

LDFLAGS	: makefile.go
	echo\ -Ttext 00001000 -Tdata 00200000 -L${LIBRARY_PATH} -lgcc -lm -lc -lpc > LDFLAGS

LDFLAGS2: makefile.go
	echo\ -Ttext 10801000 -Tdata 10A00000 -L${LIBRARY_PATH} -lgcc -lm -lc -lpc > LDFLAGS2

LDFILES	: makefile.go
	echo\ ${CRT}		> LDFILES
	echo\ ${OBJS1}		>> LDFILES
	echo\ ${SOBJS1}		>> LDFILES
	echo\ ${SOBJS2}		>> LDFILES
	echo\ ${SOBJS3}		>> LDFILES
	echo\ ${SOBJS4}		>> LDFILES
	echo\ ../lib/_lib.a	>> LDFILES

ml.h	: ${SRCS}
	func -h ${SRCS} ${HDRS}	 	> ml.h

fary.c	: ${SRCS}
	func -a lib.h ${HDRS} ${SRCS}	> fary.c

ml.dl	: ${OBJS} ${CRT} LDFLAGS LDFILES
	${LD} -o ml.dl @LDFILES @LDFLAGS

ml.dl2	: ${OBJS} ${CRT} LDFLAGS2 LDFILES
	${LD} -o ml.dl2 @LDFILES @LDFLAGS2

ml.rel	: ml.dl ml.dl2
	rel ml

ml.a	: mlinit.o _mlinit.o
	${AR} r ml.a mlinit.o _mlinit.o
	ranlib ml.a

sml.a	: smlinit.o _smlinit.o ${SOBJS}
	${AR} r sml.a smlinit.o _smlinit.o
	${AR} r sml.a ${SOBJS1}
	${AR} r sml.a ${SOBJS2}
	${AR} r sml.a ${SOBJS3}
	${AR} r sml.a ${SOBJS4}
	ranlib sml.a

_mlinit.c : ${SRCS}
	func -e lib.h ${SRCS}		> _mlinit.c
	func -f ${SRCS}			>> _mlinit.c
	func -i ML ${SRCS}		>> _mlinit.c

_smlinit.c : ${SRCS}
	func -e _ml.h ${SRCS}		> _smlinit.c
	func -f ${SRCS}			>> _smlinit.c
	func -s ML ${SRCS}		>> _smlinit.c

test	: test.o sml.a ${SLIBS}
	${CC} -o test test.o sml.a ${SLIBS} -lm

